package org.bench4q.agent.parameterization.impl;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;

public class ParameterizationParser {

	public static String parse(String text, InstanceControler insCon) {
		// Pattern pattern = Pattern.compile("<parameter className=""/>");
		String result = "";
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document document = db
					.parse(new InputSource(new StringReader(text)));
			Element root = document.getDocumentElement();
			String className = root.getAttribute("class");
			String methodName = root.getAttribute("method");
			String argString = root.getAttribute("args");
			String type = root.getAttribute("type");
			String[] args = argString.split(",");
			if (argString.trim().equals(""))
				args = new String[0];

			String name = root.getAttribute("name");
			result = insCon.getParameterByContext(name);
			if (result != null)
				return result;
			if (type.equals("crossThread")) {
				result = insCon.getParameter(name, getCurrentPackageFullName()
						+ "." + className, methodName, args);
			} else if (type.equals("inThread")) {
				result = insCon.instanceLevelGetParameter(name, className,
						methodName, args);
			}

		} catch (Exception ex) {
			return text;
		}
		return result;
	}

	private static String getCurrentPackageFullName() {
		return ParameterizationParser.class.getName().substring(0,
				ParameterizationParser.class.getName().lastIndexOf('.'));
	}
}
