package org.bench4q.agent.parameterization.impl;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.locks.ReentrantReadWriteLock;

public class ParametersFactory {
	private ParametersFactory() {

	};

	static private final ParametersFactory instance = new ParametersFactory();
	static String lockObj = "";

	static public ParametersFactory getInstance() {
		return instance;
	}

	private Map<String, Object> objMap = new HashMap<String, Object>();

	public boolean containObj(String className) {
		boolean ret = false;
		mapRWLock.readLock().lock();
		ret = objMap.containsKey(className);
		mapRWLock.readLock().unlock();
		return ret;
	}

	public Object getObj(String className) {
		Object result = null;
		mapRWLock.readLock().lock();
		result = objMap.get(className);
		mapRWLock.readLock().unlock();
		return result;
	}

	private String rootFilePath = "/home/yxsh/git/Bench4Q-Agent/parameterClass/";

	ReentrantReadWriteLock mapRWLock = new ReentrantReadWriteLock();

	public boolean createObj(String className) {
		try {
			MyFileClassLoader cl = new MyFileClassLoader();
			cl.setClassPath(rootFilePath);
			Class<?> cls = cl.loadClass(className);
			Object instance = cls.newInstance();
			mapRWLock.writeLock().lock();
			objMap.put(className, instance);

		} catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
		mapRWLock.writeLock().unlock();
		return true;
	}

}
