package org.bench4q.agent.scenario.behavior;

import java.util.Map;

import org.bench4q.agent.datacollector.DataCollector;
import org.bench4q.agent.datacollector.impl.BehaviorStatusCodeResult;
import org.bench4q.agent.parameterization.SessionObject;
import org.bench4q.agent.scenario.Parameter;

public abstract class Behavior {
	private int id;
	private String use;
	private String name;
	private Parameter[] parameters;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getUse() {
		return use;
	}

	public void setUse(String use) {
		this.use = use;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Parameter[] getParameters() {
		return parameters;
	}

	public void setParameters(Parameter[] parameters) {
		this.parameters = parameters;
	}

	public abstract boolean shouldBeCountResponseTime();

	public abstract Map<Integer, BehaviorStatusCodeResult> getBehaviorBriefResult(
			DataCollector dataStatistics);

	public String getUrl() {
		for (Parameter parameter : this.getParameters()) {
			if (parameter.getKey().equals("url")) {
				return parameter.getValue();
			}
		}
		return "";
	}

	public void distillParams(SessionObject session) {
		for (Parameter parameter : this.getParameters()) {
			String s = parameter.getValue();
			System.out.println("before Change :" + s);
			String re = session.getParam(s);
			System.out.println("after Change : " + re);
			parameter.setValue(re);
		}
	}
}
