package org.bench4q.master.api;

import java.util.UUID;

import org.bench4q.master.domain.service.TestPlanScriptResultService;
import org.bench4q.master.domain.service.UserService;
import org.bench4q.master.exception.Bench4QException;
import org.bench4q.share.models.master.ResultLoadModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("/testPlanResult")
public class TestPlanResulController extends BaseController {
	private TestPlanScriptResultService testPlanScriptResultService;

	public TestPlanScriptResultService getTestPlanScriptResultService() {
		return testPlanScriptResultService;
	}

	@Autowired
	public void setTestPlanScriptResultService(
			TestPlanScriptResultService testPlanScriptResultService) {
		this.testPlanScriptResultService = testPlanScriptResultService;
	}

	@RequestMapping(value = "/{testPlanRunId}/loadScriptBirefResults/{scriptId}/{fieldName}", method = RequestMethod.GET)
	@ResponseBody
	public ResultLoadModel loadScriptBriefResults(
			@PathVariable UUID testPlanRunId, @PathVariable int scriptId,
			@PathVariable String fieldName) throws Bench4QException {
		if (!this.checkScope(UserService.NORAML_AUTHENTICATION)) {
			throw new Bench4QException(400 + "", "not permitted",
					"/{testPlanRunId}/script/{scriptId}/{fieldName}");
		}
		ResultLoadModel ret = new ResultLoadModel();
		ret.setValueTimeModels(this.getTestPlanScriptResultService()
				.loadScriptBriefSpecificField(testPlanRunId, scriptId,
						fieldName));
		return ret;
	}

	@RequestMapping(value = "/{testPlanRunId}/loadBehaviorsBriefResults/{scriptId}/{fieldName}", method = RequestMethod.GET)
	@ResponseBody
	public ResultLoadModel loadBehaviorsBriefResults(
			@PathVariable UUID testPlanRunId, @PathVariable int scriptId,
			@PathVariable String fieldName) throws Bench4QException {
		if (!this.checkScope(UserService.NORAML_AUTHENTICATION)) {
			throw new Bench4QException("400", "not permitted",
					"/{testPlanRunId}/loadBehaviorsBriefResults/{scriptId}/{fieldName}");
		}
		return null;
	}
}
