package org.bench4q.master.domain;

import java.util.UUID;

import org.bench4q.master.domain.entity.Agent;
import org.bench4q.master.domain.entity.RunningAgentDB;
import org.bench4q.master.domain.entity.Script;

public interface RunningAgentInterface {
	public Agent getAgent();

	public int getLoadInUse();

	public int getScriptId();

	public UUID getAgentRunId();

	public boolean isBreakDown();

	public abstract class AbstractRunningAgent {

		public static RunningAgentInterface buildDegendRunningAgentDB(Agent agent,
				int loadInUse, final int scriptId, UUID agentRunId) {
			RunningAgentDB runningAgentDB = new RunningAgentDB();
			runningAgentDB.setAgent(agent);
			runningAgentDB.setAgentRunId(agentRunId);
			runningAgentDB.setLoadInUse(loadInUse);
			runningAgentDB.setScript(new Script() {
				{
					setId(scriptId);
				}
			});
			return runningAgentDB;
		}
	}
}
