package org.bench4q.master.domain.entity;

import java.util.UUID;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.bench4q.master.domain.RunningAgentInterface;
import org.bench4q.master.domain.service.AgentService;

@Entity
@Table(name = "runningAgent")
public class RunningAgentDB implements RunningAgentInterface {
	private int id;
	private Agent agent;
	private int loadInUse;
	private Script script;
	private UUID agentRunId;
	private TestPlanScript testPlanScript;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id", nullable = false)
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@ManyToOne
	@JoinColumn(name = "agentId")
	public Agent getAgent() {
		return agent;
	}

	public void setAgent(Agent agent) {
		this.agent = agent;
	}

	@Column(name = "loadInUse", nullable = false)
	public int getLoadInUse() {
		return loadInUse;
	}

	public void setLoadInUse(int loadInUse) {
		this.loadInUse = loadInUse;
	}

	@ManyToOne
	@JoinColumn(name = "scriptId")
	public Script getScript() {
		return script;
	}

	public void setScript(Script script) {
		this.script = script;
	}

	@Column(name = "agentRunId")
	public UUID getAgentRunId() {
		return agentRunId;
	}

	public void setAgentRunId(UUID agentRunId) {
		this.agentRunId = agentRunId;
	}

	@ManyToOne
	@JoinColumn(name = "testPlanScriptId")
	public TestPlanScript getTestPlanScript() {
		return testPlanScript;
	}

	public void setTestPlanScript(TestPlanScript testPlanScript) {
		this.testPlanScript = testPlanScript;
	}

	@Transient
	public int getScriptId() {
		return this.getScript().getId();
	}

	@Transient
	public boolean isBreakDown() {
		return this.getAgent().getCurrentStatus() == AgentService.AGENT_STATUS_BreakDown;
	}

}
