package org.bench4q.master.domain.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name = "Script")
public class Script {
	private int id;
	private String name;
	private String scriptContent;
	private int behaviorCount;
	private Date createDateTime;
	private User user;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id", nullable = false)
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Column(name = "name", nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "createDateTime", nullable = false)
	public Date getCreateDateTime() {
		return createDateTime;
	}

	public void setCreateDateTime(Date createDateTime) {
		this.createDateTime = createDateTime;
	}

	@Column(name = "scriptContent", columnDefinition = "LONGTEXT", nullable = false)
	public String getScriptContent() {
		return scriptContent;
	}

	public void setScriptContent(String scriptContent) {
		this.scriptContent = scriptContent;
	}

	@Column(name = "behaviorCount", nullable = false)
	public int getBehaviorCount() {
		return behaviorCount;
	}

	public void setBehaviorCount(int behaviorCount) {
		this.behaviorCount = behaviorCount;
	}

	@ManyToOne
	@JoinColumn(name = "userId", nullable = false)
	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public static Script createScriptWithoutId(String name,
			String scriptContent, User user) {
		Script script = new Script();
		script.setBehaviorCount(0);
		script.setCreateDateTime(new Date());
		script.setName(name);
		script.setScriptContent(scriptContent);
		script.setUser(user);
		return script;
	}
}
