package org.bench4q.master.domain.entity.plugin;

import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "methodParam")
public class MethodParam {
	private int id;
	private Method method;
	private String lable;
	private String name;
	private ParamType paramType;
	private String valueSeperator = ";";
	private String fieldSeperator = ",";
	private Set<MethodParamProperty> methodParamProperties;
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id", nullable = false)
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Column(name = "name", nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@ManyToOne
	@JoinColumn(name = "methodId", nullable = false)
	public Method getMethod() {
		return method;
	}

	public void setMethod(Method method) {
		this.method = method;
	}

	@Column(name = "lable")
	public String getLable() {
		return lable;
	}

	public void setLable(String lable) {
		this.lable = lable;
	}

	@OneToOne(cascade = CascadeType.ALL, orphanRemoval = true, fetch = FetchType.EAGER)
	@JoinColumn(name = "paramTypeId", nullable = false)
	public ParamType getParamType() {
		return paramType;
	}

	public void setParamType(ParamType paramType) {
		this.paramType = paramType;
	}

	@Column(name = "valueSeperator")
	public String getValueSeperator() {
		return valueSeperator;
	}

	public void setValueSeperator(String valueSeperator) {
		this.valueSeperator = valueSeperator;
	}

	@Column(name = "fieldSeperator")
	public String getFieldSeperator() {
		return fieldSeperator;
	}

	public void setFieldSeperator(String fieldSeperator) {
		this.fieldSeperator = fieldSeperator;
	}

	@OneToMany(mappedBy = "methodParam", cascade = CascadeType.ALL, orphanRemoval = true, fetch = FetchType.EAGER)
	public Set<MethodParamProperty> getMethodParamProperties() {
		return methodParamProperties;
	}

	public void setMethodParamProperties(
			Set<MethodParamProperty> methodParamProperties) {
		this.methodParamProperties = methodParamProperties;
	}

}
