package org.bench4q.master.scriptrecord.httpcapture.generator;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

public class HtmlDocumentParser {
	private Document document;
	private static Logger logger = Logger.getLogger(HtmlDocumentParser.class);

	private Document getDocument() {
		return document;
	}

	private void setDocument(Document document) {
		this.document = document;
	}

	public HtmlDocumentParser(String htmlContent, String baseUrl) {
		this.setDocument(Jsoup.parse(htmlContent, baseUrl));
	}

	public void beginParse() {

	}

	public List<ChildrenUrl> buildParentChildrenRelationship(int parentBatchId) {
		List<ChildrenUrl> result = new ArrayList<ChildrenUrl>();
		if (parentBatchId == -1) {
			return result;
		}

		Elements allChildrenLinks = new Elements();
		allChildrenLinks.addAll(this.getDocument().select("[src]"));
		allChildrenLinks.addAll(this.getDocument().select("link[href]"));

		logger.info("Following url shuold in children urls: \n");
		for (Element element : allChildrenLinks) {
			String childAbsoluteUrl = element.absUrl("src");
			if (childAbsoluteUrl.isEmpty()) {
				childAbsoluteUrl = element.absUrl("href");
			}
			logger.info(childAbsoluteUrl);
			result.add(ChildrenUrl.createChilldUrl(childAbsoluteUrl,
					parentBatchId));
		}
		return result;
	}
}
