package org.bench4q.master.scriptrecord.httpcapture.generator;

import java.util.HashMap;

public class ResponseHeader {
	public static HashMap<String, String> MIME_TYPE = new HashMap<String, String>() {
		private static final long serialVersionUID = 1L;

		{
			put("text/plain", "text/plain");
			put("text/html", "text/html");
			put("text/comma-separated-values", "text/comma-separated-values");
		}
	};
	private String respCode;
	private String contentType;
	private String charset;
	private String contentEncoding;
	private int contentLength;

	public String getRespCode() {
		return respCode;
	}

	public void setRespCode(String respCode) {
		this.respCode = respCode;
	}

	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	public String getCharset() {
		return charset;
	}

	public void setCharset(String charset) {
		this.charset = charset;
	}

	public String getContentEncoding() {
		return contentEncoding;
	}

	public void setContentEncoding(String contentEncoding) {
		this.contentEncoding = contentEncoding;
	}

	public int getContentLength() {
		return contentLength;
	}

	public void setContentLength(int contentLength) {
		this.contentLength = contentLength;
	}

	boolean isValidResponseHeader() {
		return (getContentType() != null)
				&& (MIME_TYPE.containsKey(getContentType()))
				&& (getRespCode() != null);
	}

	boolean isHtmlContentType() {
		return getContentType().toLowerCase().contains("text/html");
	}

	boolean isGoodRequest() {
		return this.getRespCode().startsWith("200");
	}
}
