package org.bench4q.master.testplan.highavailable.faultolerence;

import org.bench4q.master.domain.entity.Agent;
import org.bench4q.master.helper.ApplicationContextHelper;
import org.bench4q.master.infrastructure.communication.AgentMessenger;
import org.bench4q.master.testplan.highavailable.HighAvailablePool;

public class BriefAgentFault implements FaultTolerance {
	private HighAvailablePool haPool;
	private AgentMessenger agentMessenger;
	private Agent agent;

	private HighAvailablePool getHaPool() {
		return haPool;
	}

	private void setHaPool(HighAvailablePool haPool) {
		this.haPool = haPool;
	}

	private AgentMessenger getAgentMessenger() {
		return agentMessenger;
	}

	private void setAgentMessenger(AgentMessenger agentMessenger) {
		this.agentMessenger = agentMessenger;
	}

	private Agent getAgent() {
		return agent;
	}

	private void setAgent(Agent agent) {
		this.agent = agent;
	}

	BriefAgentFault(Agent agent) {
		this.setAgent(agent);
		this.setHaPool(ApplicationContextHelper.getContext().getBean(
				HighAvailablePool.class));
		this.setAgentMessenger(ApplicationContextHelper.getContext().getBean(
				AgentMessenger.class));
	}

	public void doTolerance() {
		if (isLiving()) {
			return;
		}

		synchronized (this.getHaPool().getPool()) {
			this.getHaPool().checkHeartBeat(this.getAgent());
		}
	}

	private boolean isLiving() {
		return this.getAgentMessenger().askLiving(
				this.getAgent().getHostName(), this.getAgent().getPort()) != null;
	}
}
