package org.bench4q.master.testplan.schedulscript;

import java.util.TimerTask;

import org.bench4q.master.domain.RunningScriptInterface;
import org.bench4q.master.domain.entity.TestPlanScript;
import org.bench4q.master.domain.repository.TestPlanRepository;
import org.bench4q.master.domain.service.TestPlanEngine;
import org.bench4q.master.helper.ApplicationContextHelper;

/**
 * 
 * @author coderfengyun
 * 
 * @description This Task will do two things: one is to remove the runningAgent
 *              from testPlanContext, and the other is to remove the
 *              runningAgentFrom HA Blotters
 */
public class ExecutionOverTask extends TimerTask {
	private RunningScriptInterface runningScript;
	private TaskCompleteCallback taskCompleteCallback;
	private TestPlanRepository testPlanRepository;

	public RunningScriptInterface getRunningScript() {
		return runningScript;
	}

	public void setRunningScriptModel(RunningScriptInterface runningScript) {
		this.runningScript = runningScript;
	}

	private TaskCompleteCallback getTaskCompleteCallback() {
		return taskCompleteCallback;
	}

	private void setTaskCompleteCallback(
			TaskCompleteCallback taskCompleteCallback) {
		this.taskCompleteCallback = taskCompleteCallback;
	}

	private TestPlanRepository getTestPlanRepository() {
		return testPlanRepository;
	}

	private void setTestPlanRepository(TestPlanRepository testPlanRepository) {
		this.testPlanRepository = testPlanRepository;
	}

	public ExecutionOverTask(RunningScriptInterface runningScript) {
		this.setRunningScriptModel(runningScript);
		this.setTaskCompleteCallback(ApplicationContextHelper.getContext()
				.getBean(TestPlanEngine.class));
		this.setTestPlanRepository(ApplicationContextHelper.getContext()
				.getBean(TestPlanRepository.class));
	}

	@Override
	public void run() {
		RunningScriptInterface runningScript = this.getRunningScript()
				.doForComplete();
		TestPlanScript testPlanScript = (TestPlanScript) runningScript;
		// TODO : update testplan
		this.getTestPlanRepository().updateEntity(testPlanScript.getTestPlan());
		// 2: do for runningAgent in HA blotters, And TestPlanContainer
		this.getTaskCompleteCallback().doTaskComplete(
				this.getRunningScript().getTestPlanID());
		System.out.println("execute ExecutionOverTask");
	}
}
