package org.bench4q.master.test.controller;

import static org.junit.Assert.*;

import java.io.IOException;

import javax.xml.bind.JAXBException;

import org.bench4q.share.communication.HttpRequester.HttpResponse;
import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.master.plugin.PluginResponseModel;
import org.junit.Assert;
import org.junit.Test;

public class PluginControllerTest extends TestBase {
	private final String URLSTRING = BASE_URL + "/plugin";

	public String getURLSTRING() {
		return URLSTRING;
	}

	@Test
	public void testLoadPluginList() throws JAXBException, IOException {
		this.setAccessTocken(this.login());
		String url = URLSTRING + "/loadPluginList";
		HttpResponse httpResponse = this.httpRequester.sendPost(url, null,
				makeAccessTockenMap(this.getAccessTocken()));
		System.out.println(httpResponse.getContent());
		PluginResponseModel pluginResponseModel = (PluginResponseModel) MarshalHelper
				.tryUnmarshal(PluginResponseModel.class,
						httpResponse.getContent());
		Assert.assertTrue(pluginResponseModel.getPluginList().size() > 0);
	}

	@Test
	public void testLoadMethodNameList() throws IOException, JAXBException  {
		this.setAccessTocken(this.login());
		String url = URLSTRING + "/loadPluginList";
		HttpResponse httpResponse = this.httpRequester.sendPost(url, null,
				makeAccessTockenMap(this.getAccessTocken()));
		PluginResponseModel pluginResponseModel = (PluginResponseModel) MarshalHelper
				.tryUnmarshal(PluginResponseModel.class,
						httpResponse.getContent());
		assertTrue(pluginResponseModel.getPluginList().size() > 0);
		String pluginName = pluginResponseModel.getPluginList().get(0);
		String urlForLoadMethod = URLSTRING + "/loadMethodList/" + pluginName;
		httpResponse = this.httpRequester.sendPost(urlForLoadMethod, null,
				makeAccessTockenMap(this.getAccessTocken()));
		System.out.println(httpResponse.getContent());
		pluginResponseModel = (PluginResponseModel) MarshalHelper.unmarshal(
				PluginResponseModel.class, httpResponse.getContent());
		assertNotNull(pluginResponseModel);
		assertEquals(1, pluginResponseModel.getMethodList().size());
	}

	@Test
	public void testDeletePlugin() throws IOException {
		this.setAccessTocken(this.login());
		String url = URLSTRING + "/loadPluginList";
		HttpResponse httpResponse = this.httpRequester.sendPost(url, null,
				makeAccessTockenMap(this.getAccessTocken()));
		PluginResponseModel pluginResponseModel = (PluginResponseModel) MarshalHelper
				.tryUnmarshal(PluginResponseModel.class,
						httpResponse.getContent());
		assertTrue(pluginResponseModel.getPluginList().size() > 0);
		String pluginName = pluginResponseModel.getPluginList().get(0);
		url = URLSTRING + "/deletePlugin" + "/" + pluginName;
		httpResponse = this.httpRequester.sendPost(url, null,
				makeAccessTockenMap(this.getAccessTocken()));
		pluginResponseModel = (PluginResponseModel) MarshalHelper.tryUnmarshal(
				PluginResponseModel.class, httpResponse.getContent());
		Assert.assertTrue(pluginResponseModel.isSuccess());
	}

}
