package org.bench4q.master.test.controller;

import java.io.IOException;

import javax.xml.bind.JAXBException;

import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.bench4q.master.test.testplan.TestPlanTester;
import org.bench4q.share.communication.HttpRequester.HttpResponse;
import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.master.TestPlanModel;
import org.junit.Test;

import static org.junit.Assert.*;

public class TestPlanControllerTest extends TestBase_MakeUpTestPlan {
	private String url = BASE_URL + "/testPlan";

	public TestPlanControllerTest() {
	}

	@Test
	public void runTestPlanWithoutLogOn() throws JAXBException, IOException {
		HttpResponse httpResponse = this.httpRequester.sendPostXml(this.url
				+ "/runTestPlanWithTestPlanModel", MarshalHelper.marshal(
				TestPlanModel.class,
				createATestPlanWithOneScript(TestPlanTester.SCRIPTID1)), null);
		System.out.println(httpResponse.getContent());
		assertEquals(400, httpResponse.getCode());
	}

	@Test
	public void runTestPlanWithNullMonitorList() throws IOException,
			JAXBException {
		HttpResponse httpResponse = this.httpRequester
				.sendPostXml(
						this.url + "/runTestPlanWithTestPlanModel",
						MarshalHelper
								.marshal(
										TestPlanModel.class,
										TestPlanTester
												.createATestPlanWithNullMonitorList(TestPlanTester.SCRIPTID1)),
						makeAccessTockenMap(accessTocken));
		System.out.println(httpResponse.getContent());
		assertEquals(200, httpResponse.getCode());
	}

	public void runTestPlanWithZeroMonitor() throws IOException, JAXBException {
		HttpResponse httpResponse = this.httpRequester
				.sendPostXml(
						this.url + "/runTestPlanWithTestPlanModel",
						MarshalHelper
								.marshal(
										TestPlanModel.class,
										TestPlanTester
												.createATestPlanWithZeroMonitor(TestPlanTester.SCRIPTID1)),
						makeAccessTockenMap(accessTocken));
		System.out.println(httpResponse.getContent());
		assertEquals(200, httpResponse.getCode());
	}
}
