package org.bench4q.master.test.controller;

import java.io.IOException;
import javax.xml.bind.JAXBException;

import org.bench4q.share.communication.HttpRequester.HttpResponse;
import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.master.AuthorizeResponseModel;
import org.junit.Test;

import static org.junit.Assert.*;

public class UserControllerTest extends TestBase {

	@Test
	public void testNormalAuth() throws IOException, JAXBException {
		String urlString = BASE_URL
				+ "/user/normalAuthorize?userName=chen&password=123";
		HttpResponse httpResponse = this.httpRequester.sendGet(urlString, null,
				null);
		AuthorizeResponseModel ret = (AuthorizeResponseModel) MarshalHelper
				.unmarshal(AuthorizeResponseModel.class,
						httpResponse.getContent());
		assertTrue(ret.isSuccess());
	}

	@Test
	public void testAdminAuth() throws IOException, JAXBException {
		String url = BASE_URL
				+ "/user/adminAuthorize?userName=chen&password=123";
		HttpResponse httpResponse = this.httpRequester.sendGet(url, null, null);
		AuthorizeResponseModel ret = (AuthorizeResponseModel) MarshalHelper
				.unmarshal(AuthorizeResponseModel.class,
						httpResponse.getContent());
		assertTrue(ret.isSuccess());
	}

}
