package org.bench4q.master.test.domain;

import static org.junit.Assert.*;

import java.util.Map;
import java.util.UUID;

import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.domain.entity.TestPlanScript;
import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.bench4q.master.testplan.highavailable.AgentRunBlotter;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:service-test-context.xml" })
public class Test_HighAvailable extends TestBase_MakeUpTestPlan {

	@Before
	public void prepare() {

	}

	@After
	public void cleanUp() {

	}

	@Test
	public void testSubstituteOnBoard() throws InterruptedException {
		submitATestPlanWithOneScript();
		prepareForTestPlanRunning();
		assertEquals(Long.valueOf(1000), this.getHaPool().getMaxAvailableLoad());
		assertEquals(1000, this.getHaPool().getCurrentAvailableLoad());

		this.getTestPlanEngine().doRunTestPlan(getTestPlanRunIdUuid());

		assertEquals(Long.valueOf(1000), this.getHaPool().getMaxAvailableLoad());
		assertEquals(500, this.getHaPool().getCurrentAvailableLoad());
		TestPlan testPlan = this.getTestPlanRepository().getRunningTestPlanBy(
				getTestPlanRunIdUuid());
		TestPlanScript testPlanScriptBeforeSubmit = testPlan
				.extracSpecifiedScript(getScriptId());
		Map<UUID, AgentRunBlotter> agentRunBlottersBeforeKill = this
				.getHaPool().getAgentRunBlotters();
		assertEquals(1, agentRunBlottersBeforeKill.size());
		assertEquals(1, testPlanScriptBeforeSubmit.getSampler()
				.getRunningAgents().size());
		this.getHaPool().timerTask();
		for (AgentRunBlotter agentRunBlotter : agentRunBlottersBeforeKill
				.values()) {
			while (this.getAgentMessenger().askLiving(
					agentRunBlotter.getRunningAgent().getAgent().getHostName(),
					6565) != null) {
				System.out.println("This need agent "
						+ agentRunBlotter.getRunningAgent().getAgent()
								.getHostName() + " to be killed");
				Thread.sleep(1000);
			}
		}
		this.getHaPool().timerTask();
		assertEquals(Long.valueOf(500), this.getHaPool().getMaxAvailableLoad());
		assertEquals(0, this.getHaPool().getCurrentAvailableLoad());
		this.getHaPool().timerTask();
		assertEquals(2, agentRunBlottersBeforeKill.size());
		TestPlan testPlanAfterSubstitute = this.getTestPlanRepository()
				.getTestPlanBy(getTestPlanRunIdUuid());
		TestPlanScript extracSpecifiedScript = testPlanAfterSubstitute
				.extracSpecifiedScript(getScriptId());
		assertEquals(2, extracSpecifiedScript.getRunningAgentsDB().size());
		cleanUpForTestPlanRunning();
	}

	@Test
	public void testCurrentAvailableLoad() {
		this.getHaPool().timerTask();
		assertNotEquals(0, this.getHaPool().getCurrentAvailableLoad());
	}
}
