package org.bench4q.master.test.domain;

import static org.junit.Assert.*;

import java.util.Date;

import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.domain.entity.TestPlanScript;
import org.bench4q.master.domain.testplan.RunningScriptSampler;
import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.bench4q.share.models.master.statistics.ScriptBriefResultModel;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:service-test-context.xml" })
public class Test_RunningScriptSampler extends TestBase_MakeUpTestPlan {
	private RunningScriptSampler runningScriptSampler;

	private RunningScriptSampler getRunningScriptSampler() {
		return runningScriptSampler;
	}

	private void setRunningScriptSampler(
			RunningScriptSampler runningScriptSampler) {
		this.runningScriptSampler = runningScriptSampler;
	}

	@Before
	public void prepare() {
		prepareForTestPlanRunning();
		this.submitATestPlanWithOneScript();
		TestPlan testPlan = fetchTestPlan();
		testPlan.run();
		this.getTestPlanRepository().updateEntity(testPlan);
		TestPlan testPlanInRunning = fetchTestPlan();
		TestPlanScript testPlanScript = testPlanInRunning
				.extracSpecifiedScript(getScriptId());
		this.setRunningScriptSampler(new RunningScriptSampler(testPlanScript
				.getRunningAgentsDB()));
	}

	@After
	public void cleanUp() {
		cleanUpForTestPlanRunning();
	}

	private TestPlan fetchTestPlan() {
		return this.getTestPlanRepository().getTestPlanBy(
				getTestPlanRunIdUuid());
	}

	@Test
	public void testGetScriptBrief() throws InterruptedException {
		ScriptBriefResultModel resultModel = this.getRunningScriptSampler()
				.getScriptBrief();
		Thread.sleep(100);
		assertNotNull(resultModel);
		assertTrue(resultModel.getvUserCount() > 0);
		assertTrue(resultModel.getSamplingTime().before(new Date())
				&& resultModel.getSamplingTime().after(new Date(0)));
	}
}
