package org.bench4q.master.test.domain;

import static org.junit.Assert.*;
import java.util.UUID;
import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.domain.entity.TestPlanScript;
import org.bench4q.master.domain.testplan.RunningScriptSampler;
import org.bench4q.master.domain.testplan.TestScriptResultSave;
import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:service-test-context.xml" })
public class Test_TestScriptResultSave extends TestBase_MakeUpTestPlan {

	private TestScriptResultSave testScriptResultSave;
	private RunningScriptSampler runningScriptSampler;
	private UUID testPlanRunId;
	private int scriptId;

	public TestScriptResultSave getTestScriptResultSave() {
		return testScriptResultSave;
	}

	@Autowired
	public void setTestScriptResultSave(
			TestScriptResultSave testScriptResultSave) {
		this.testScriptResultSave = testScriptResultSave;
	}

	@Before
	public void setUp() {
		prepareForTestPlanRunning();
		this.submitATestPlanWithOneScript();
		TestPlan testPlan = fetchTestPlan();
		this.testPlanRunId = UUID.fromString(testPlan.getTestPlanRunId());
		testPlan.run();
		this.getTestPlanRepository().updateEntity(testPlan);
		TestPlan testPlanInRunning = fetchTestPlan();
		TestPlanScript testPlanScript = testPlanInRunning
				.extracSpecifiedScript(getScriptId());
		this.scriptId = getScriptId();
		this.runningScriptSampler = new RunningScriptSampler(
				testPlanScript.getRunningAgentsDB());
	}

	@Test
	public void testDoSaveResult() {
		assertTrue(this.getTestScriptResultSave().doSaveResult(
				this.testPlanRunId, this.scriptId,
				this.runningScriptSampler.getScriptBrief(),
				this.runningScriptSampler.getScriptBrief().getSamplingTime()));
	}

	@After
	public void clean() {
		cleanUpForTestPlanRunning();
	}

	private TestPlan fetchTestPlan() {
		return this.getTestPlanRepository().getTestPlanBy(
				getTestPlanRunIdUuid());
	}

}
