package org.bench4q.master.test.recordscript;

import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import org.apache.commons.io.FileUtils;
import org.bench4q.master.scriptrecord.httpcapture.generator.ChildrenUrl;
import org.bench4q.master.test.TestRecordBase;
import org.junit.Test;

public class TestDomGenerator extends TestRecordBase {
	private URL url = this.getClass().getResource("testcase.html");

	public TestDomGenerator() {
		init();
	}

	@Test
	public void testDomParser() throws IOException {
		this.getCodeGenerator()
				.getScriptAdapter()
				.insertUserBehaviorsToScenario(
						createUserBehaviorModel(parentUrl));
		this.getCodeGenerator().doParseHtmlContent(
				FileUtils.readFileToString(new File(url.getPath())), parentUrl);
		assertTrue(this.getCodeGenerator().getScriptAdapter().getChildrenUrls()
				.size() == 8);
		for (ChildrenUrl childrenUrl : this.getCodeGenerator()
				.getScriptAdapter().getChildrenUrls()) {
			assertTrue(childrenUrl.getParentBatchId() == 0);
		}
	}

	@Test
	public void testDomParserWithinAdapter() throws IOException {
		this.getAdpater().insertUserBehaviorsToScenario(
				createUserBehaviorModel(independentUrl));
		this.getAdpater().insertUserBehaviorsToScenario(
				createUserBehaviorModel(parentUrl));
		this.getCodeGenerator().doParseHtmlContent(
				FileUtils.readFileToString(new File(this.url.getPath())),
				parentUrl);
		System.out.println(this.getCodeGenerator().getScriptAdapter()
				.getChildrenUrls().size());
		assertTrue(this.getCodeGenerator().getScriptAdapter().getChildrenUrls()
				.size() == 8);

		for (ChildrenUrl childrenUrl : this.getAdpater().getChildrenUrls()) {
			assertTrue(childrenUrl.getParentBatchId() == 1);
		}
	}

	@Test
	public void testDomParserWithIncorrectParentUrl() throws IOException {
		this.getAdpater().insertUserBehaviorsToScenario(
				createUserBehaviorModel(parentUrl));
		this.getAdpater().insertUserBehaviorsToScenario(
				createUserBehaviorModel(independentUrl));
		this.getCodeGenerator().doParseHtmlContent(
				FileUtils.readFileToString(new File(this.url.getPath())),
				parentUrl + "error");
		assertTrue(this.getCodeGenerator().getScriptAdapter().getChildrenUrls()
				.size() == 0);
	}

}
