package org.bench4q.mater.test.entity;

import static org.junit.Assert.*;

import org.bench4q.master.domain.entity.Monitor;
import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:service-test-context.xml" })
public class Test_Monitor extends TestBase_MakeUpTestPlan {

	@Before
	public void prepare() {
		prepareForTestPlanRunning();
		submitATestPlanWithOneScript();
	}

	@Test
	public void testDoAfterRun() {
		TestPlan testPlan = this.getTestPlanRepository().getTestPlanBy(
				getTestPlanRunIdUuid());
		assertEquals(1, testPlan.getMonitors().size());
		for (Monitor monitor : testPlan.getMonitors()) {
			monitor.doAfterRun();
		}
		for (Monitor monitor : getTestPlanRepository().getTestPlanBy(
				getTestPlanRunIdUuid()).getMonitors()) {
			assertEquals(5, monitor.getResults().size());
		}
	}

	@After
	public void clear() {
		cleanUpForTestPlanRunning();
	}

}
