package org.bench4q.mater.test.entity;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import org.bench4q.master.domain.entity.Monitor;
import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.domain.factory.TestPlanFactory;
import org.bench4q.master.domain.service.TestPlanService;
import org.bench4q.master.test.TestBase_MakeUpTestPlan;
import org.bench4q.share.enums.master.TestPlanStatus;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:service-test-context.xml" })
public class Test_TestPlan extends TestBase_MakeUpTestPlan {

	private TestPlanService testPlanService;
	private TestPlanFactory testPlanFactory;

	public TestPlanService getTestPlanService() {
		return testPlanService;
	}

	@Autowired
	public void setTestPlanService(TestPlanService testPlanService) {
		this.testPlanService = testPlanService;
	}

	public TestPlanFactory getTestPlanFactory() {
		return testPlanFactory;
	}

	@Autowired
	public void setTestPlanFactory(TestPlanFactory testPlanFactory) {
		this.testPlanFactory = testPlanFactory;
	}

	@Before
	public void prepare() {
		this.getHaPool().timerTask();
		 submitATestPlanWithOneScript();
	}

	@After
	public void cleanUp() throws InterruptedException {
		cleanUpForTestPlanRunning();
	}

	@Test
	public void testDoAfterRun() throws InterruptedException {
		assertNotNull(getTestPlanRunIdUuid());
		TestPlan testPlanInDomain = this.getTestPlanFactory().convertToDomain(
				this.getTestPlanRepository().getTestPlanBy(
						getTestPlanRunIdUuid()));
		assertEquals(TestPlanStatus.InRunning,
				testPlanInDomain.run());
		Thread.sleep(4000);
		for (Monitor monitor : getTestPlan().getMonitors()) {
			assertTrue(monitor.getResults().size()>0);
		}
	}

	private TestPlan getTestPlan() {
		TestPlan testPlanFromRepo = this.getTestPlanRepository().getTestPlanBy(
				getTestPlanRunIdUuid());
		TestPlan testPlanInDomain = this.getTestPlanFactory().convertToDomain(
				testPlanFromRepo);
		return testPlanInDomain;
	}

}
