package org.bench4q.share.helper;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

public class MarshalHelper {

	public static String marshal(Class<?> classToMarshal, Object input)
			throws JAXBException {
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		Marshaller marshaller;
		marshaller = JAXBContext.newInstance(classToMarshal).createMarshaller();
		marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
		marshaller.marshal(input, os);
		return os.toString();
	}

	public static Object unmarshal(Class<?> classToUnmarshal, String input)
			throws JAXBException {
		Unmarshaller unmarshaller;
		unmarshaller = JAXBContext.newInstance(classToUnmarshal)
				.createUnmarshaller();

		return unmarshaller
				.unmarshal(new ByteArrayInputStream(input.getBytes()));

	}

	public static void main(String args[]) {
	}

	/**
	 * 
	 * @param classToUnmarshal
	 * @param input
	 * @return null if there is an exception happened.
	 */
	public static Object tryUnmarshal(Class<?> classToUnmarshal, String input) {
		try {
			return unmarshal(classToUnmarshal, input);
		} catch (Exception e) {
			return null;
		}
	}

	public static String tryMarshal(Object result) {
		try {
			return marshal(result.getClass(), result);
		} catch (Exception e) {
			return null;
		}
	}
}
