package org.bench4q.web.TestPlan;

import java.util.List;
import java.util.Map;

import javax.xml.bind.JAXBException;

import org.bench4q.share.models.master.ScriptModel;
import org.bench4q.share.models.master.TestPlanResultModel;
import org.bench4q.web.exception.CustomGenericException;
import org.bench4q.web.model.WebTestPlanResultModel;
import org.bench4q.web.service.BaseService;
import org.bench4q.web.service.CommunicateWithMaster;
import org.bench4q.web.service.ScriptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class TestPlanFeature {
	private CommunicateWithMaster communicateWithMaster;
	private String baseUrl ="testPlan";
	private ScriptService scriptService;

	private CommunicateWithMaster getCommunicateWithMaster() {
		return communicateWithMaster;
	}

	@Autowired
	private void setCommunicateWithMaster(
			CommunicateWithMaster communicateWithMaster) {
		this.communicateWithMaster = communicateWithMaster;
	}

	public ScriptService getScriptService() {
		return scriptService;
	}

	@Autowired
	public void setScriptService(ScriptService scriptService) {
		this.scriptService = scriptService;
	}
	public TestPlanResultModel getRunningTestPlanModel(String accessToken,
			String testPlanId, String caller) throws CustomGenericException {
		String url = this.baseUrl + "/getRunningInfo";
		caller = "getRunningTestPlanModel";
		Map<String, String> params = BaseService.makeParamsMap("testPlanId",
				testPlanId);
		return (TestPlanResultModel) this.getCommunicateWithMaster()
				.getResponseModel(accessToken, url, TestPlanResultModel.class,
						params, caller);
	}

	public WebTestPlanResultModel getTestPlanInfo(String accessToken,
			String testPlanId, String caller) throws CustomGenericException,
			JAXBException {
		caller = caller + "_TestPlanFeature:getTestPlanInfo";
		String url = this.baseUrl + "/getRunningInfo";
		Map<String, String> params = BaseService.makeParamsMap("testPlanId",
				testPlanId);
		TestPlanResultModel testPlanResultModel = (TestPlanResultModel) this
				.getCommunicateWithMaster().getResponseModel(accessToken, url,
						TestPlanResultModel.class, params, caller);
		WebTestPlanResultModel webTestPlanResultModel = new WebTestPlanResultModel(
				testPlanResultModel);
		List<ScriptModel> scriptModels = this.getScriptService().queryScripts(
				testPlanResultModel.getScriptIds(), accessToken);
		webTestPlanResultModel.setScriptIdNameMap(this.getScriptService()
				.getScriptIdNameMap(scriptModels));
		return webTestPlanResultModel;
	}
}
