package org.bench4q.web.exception;

import javax.xml.bind.JAXBException;

import org.apache.log4j.Logger;
import org.bench4q.web.model.BaseResponseModel;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

@ControllerAdvice
public class GlobalExceptionController {
	private Logger logger = Logger.getLogger(GlobalExceptionController.class);

	@ExceptionHandler(CustomGenericException.class)
	@ResponseBody
	public BaseResponseModel handleCustomException(CustomGenericException ex) {
		logger.error(ex,ex.fillInStackTrace());
		BaseResponseModel responseModel = new BaseResponseModel(false,
				ex.getErrorMessage() + "source:" + ex.getSource());
		return responseModel;
	}

	// 处理所有异常，自定义异常之外的异常都执行到这里.

	@ExceptionHandler(JAXBException.class)
	public BaseResponseModel handleJAXBExceptionException(JAXBException ex) {
		logger.error(ex,ex.fillInStackTrace());
		BaseResponseModel responseModel = new BaseResponseModel(false,
				ex.getMessage());
		return responseModel;

	}

	@ExceptionHandler(Exception.class)
	@ResponseStatus(value=HttpStatus.INTERNAL_SERVER_ERROR)
	public void handleAllException(Exception e) {

		logger.error(e,e.fillInStackTrace());
	}

}
