package org.bench4q.web.service;

import java.util.ArrayList;
import java.util.List;

import org.bench4q.web.exception.CustomGenericException;
import org.bench4q.web.model.ResultInfoModel;
import org.bench4q.web.model.SutInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class MonitorDescriptionInfoService extends BaseService {
	private MonitorService monitorService;

//	private MonitorService getMonitorService() {
//		return monitorService;
//	}

	@Autowired
	private void setMonitorService(MonitorService monitorService) {
		this.monitorService = monitorService;
	}

	public SutInfo getSutInfo(String ip, String port, String accessToken,
			String testPlanId) throws CustomGenericException {
		SutInfo sutInfo = new SutInfo();
		sutInfo.setIp(ip);
		sutInfo.setPort(port);
		List<ResultInfoModel> resultInfoModels = new ArrayList<ResultInfoModel>();
		ResultInfoModel cpuInfoModel = createCpuResultInfoModel("cpu",
				this.monitorService.getCpuList(accessToken, testPlanId, ip,
						port));
		if (cpuInfoModel != null)
			resultInfoModels.add(cpuInfoModel);
		System.out.println("ok");
//		ResultInfoModel networkInfoModel = createNetworkResultInfoModel(
//				"network",
//				this.getMonitorService().getNetworkList(accessToken,
//						testPlanId, ip, port));
//		if (networkInfoModel != null)
//			resultInfoModels.add(networkInfoModel);
		resultInfoModels.add(createMemoryResultInfoModel("Memory"));

		sutInfo.setChildResults(resultInfoModels);
		return sutInfo;

	}

//	private ResultInfoModel createNetworkResultInfoModel(String resultName,
//			List<String> results) {
//		if (results.size() <= 0)
//			return null;
//		ResultInfoModel resultInfoModel = new ResultInfoModel(resultName,
//				new ArrayList<ResultInfoModel>());
//		for (String result : results) {
//			resultInfoModel.getChildResults().add(getNetworkResultInfo(result));
//		}
//		return resultInfoModel;
//	}

	private ResultInfoModel createMemoryResultInfoModel(String resultName) {

		ResultInfoModel resultInfoModel = new ResultInfoModel(resultName,
				new ArrayList<ResultInfoModel>());

		resultInfoModel.getChildResults().add(getMemoryResultInfo());

		return resultInfoModel;
	}

	private ResultInfoModel createCpuResultInfoModel(String resultName,
			List<String> results) {
		if (results.size() <= 0)
			return null;
		ResultInfoModel resultInfoModel = new ResultInfoModel(resultName,
				new ArrayList<ResultInfoModel>());
		for (String result : results) {
			resultInfoModel.getChildResults().add(getCpuResultInfo(result));
		}
		return resultInfoModel;
	}

	private ResultInfoModel getCpuResultInfo(String result) {
		String[] fields = new String[] { "processorTimePercent",
				"processorTimePercent", "privilegedTimePercent" };
		return getResultInfoModel(result, fields);
	}

//	private ResultInfoModel getNetworkResultInfo(String result) {
//		String[] fields = new String[] { "bytesTotalPerSecond",
//				"bytesReceivedPerSecond", "bytesReceivedPerSecond" };
//		return getResultInfoModel(result, fields);
//	}

	private ResultInfoModel getMemoryResultInfo() {
		String result = "Result";
		String[] fields = new String[] { "pagesPerSecond",
				"pagesInputPerSecond", "pagesOutputPerSecond", "cacheBytes",
				"committedBytes", "availableKiloBytes" };
		return getResultInfoModel(result, fields);
	}
}
