<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<html>
<head>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<meta charset="utf-8">
<title>Bench4Q</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description"
	content="Bench4Q, a new method for QOS benchmarking.">
<meta name="author" content="Kai Ren">
<title>Create scripts by yourself.</title>
<!-- The styles -->
<link rel="shortcut icon" href="img/bench4q.png">
<link id="bs-css" href="css/bootstrap-cerulean.css" rel="stylesheet">
<style type="text/css">
body {
	padding-bottom: 40px;
}

.sidebar-nav {
	padding: 9px 0;
}
</style>
<link href="css/bootstrap-responsive.css" rel="stylesheet">
<link href="css/charisma-app.css" rel="stylesheet">
<link href="css/jquery-ui-1.8.21.custom.css" rel="stylesheet">
<link href='css/chosen.css' rel='stylesheet'>
<link href='css/uniform.default.css' rel='stylesheet'>
<link href='css/colorbox.css' rel='stylesheet'>
<link href='css/jquery.noty.css' rel='stylesheet'>
<link href='css/noty_theme_default.css' rel='stylesheet'>
<link href='css/elfinder.min.css' rel='stylesheet'>
<link href='css/elfinder.theme.css' rel='stylesheet'>
<link href='css/opa-icons.css' rel='stylesheet'>
<link href='css/uploadify.css' rel='stylesheet'>
<link href='css/buttons.css' rel='stylesheet'>
<link href='bench4q-css/plugin.css' rel='stylesheet'>

<!-- The HTML5 shim, for IE6-8 support of HTML5 elements -->
<!--[if lt IE 9]>
	  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->

<!-- The fav icon -->
<link rel="shortcut icon" href="img/favicon.ico">

</head>

<body>
	<fmt:bundle basename="i18n">
		<!-- topbar starts -->
		<jsp:include page="publiccontrol/navigatebar.jsp"></jsp:include>
		<!-- topbar ends -->
		<div class="container-fluid">
			<div class="row-fluid">
				<jsp:include page="publiccontrol/leftmenubar.jsp"></jsp:include>
				<noscript>
					<div class="alert alert-block span10">
						<h4 class="alert-heading">
							<fmt:message key="warning" />
							!
						</h4>
						<p>
							<fmt:message key="warningcontent1" />
							<a href="http://en.wikipedia.org/wiki/JavaScript" target="_blank">JavaScript</a>
							<fmt:message key="warningcontent2" />
							.
						</p>
					</div>
				</noscript>

				<div id="content" class="span10">
					<!-- content starts -->
					<div>
						<ul class="breadcrumb">
							<li><a href="homepage.jsp"><fmt:message key="home" /></a> <span
								class="divider">/</span></li>
							<li><a href="#"><fmt:message key="scriptmanagement" /></a><span
								class="divider">/</span></li>
							<li><a href="#">自制脚本</a></li>
						</ul>
					</div>

					<div class="row-fluid sortable">
						<div class="box span5">
							<div>
								<div class="box-header well" data-original-title>
									<i class="icon-pencil" style="float: left;"></i>
									<h2>
										<span>Plug-ins</span>
									</h2>
									<div class="box-icon">
										<a href="#" class="btn btn-setting btn-round"><i
											class="icon-plus"></i></a> <a href="#" class="btn btn-round"><i
											class="icon-list"></i></a> <a href="#"
											class="btn btn-minimize btn-round"><i
											class="icon-chevron-up"></i></a>
									</div>
								</div>
								<div class="box-content">
									<div class="operatePlugins  center">
										<div class="span8" style="float: left;">
											<div id="pluginArea"></div>
										</div>
										<div class="pluginButton">
											<p>
												<button type="submit" class="btn btn-inverse" id="addPlugin"
													onClick="addPlugin();">Add</button>
											</p>

											<p>
												<button type="submit" class="btn btn-inverse"
													id="removePlugin" onClick="removePlugin();">Remove</button>
											</p>
											<p>
												<button type="submit" class="btn btn-inverse"
													id="removeAllPlugin" onClick="#">Remove all</button>
											</p>
										</div>
									</div>
								</div>
							</div>
						</div>
						<!--/span-->
						<!-- Behavior start -->
						<div class="box span5" style="float: left;">
							<div>
								<div class="box-header well" data-original-title>
									<i class="icon-pencil" style="float: left;"></i>
									<h2>
										<i></i> Behavior
									</h2>
									<div class="box-icon">
										<a href="#" class="btn btn-setting btn-round"><i
											class="icon-plus"></i></a> <a href="#" class="btn btn-round"><i
											class="icon-list"></i></a> <a href="#"
											class="btn btn-minimize btn-round"><i
											class="icon-chevron-up"></i></a>
									</div>
								</div>
								<div class="box-content">
									<div class="operatePlugins center">
										<div class="span8 behavior" style="float: left;">
											<div id="behaviorArea">
											
											</div>
										</div>
										<div class="behaviorButton">
											<p>
												<button type="submit" class="btn btn-inverse"
													id="insertBehavior_Plugin" onClick="insertPlugin();">Insert</button>
											</p>

											<p>
												<button type="submit" class="btn btn-inverse"
													id="removeBehavior_Plugin" onClick="removeInsertPlugin();">Remove</button>
											</p>
										</div>
									</div>

								</div>
							</div>
						</div>

						<div id="showPluginMethod">
							<!-- 显示方法文档，开始动态生成 ,只显示一个-->


						</div>
					</div>

				</div>
				<!--/row-->
				<!-- content ends -->
			</div>
			<!--/#content.span10-->
		</div>

		<hr>

		<div class="modal hide fade span4" id="myModal_Plugin">
			<div class="modal-header">
				<button type="button" id="myModal-close" class="close"
					data-dismiss="modal">×</button>
				<h3>Add a new plug-in</h3>
			</div>
			<div class="modal-body" style="height: 260px;">
				<div class="inset scroll" id="choosePlugin">
					<!-- 显示plugin列表 -->


				</div>
			</div>
			<div class="modal-footer">

				<button type="button" class="btn btn-inverse"
					onClick="pluginFinish();" id="pluginFinish">Finish</button>
				<button type="button" class="btn btn-inverse"
					onClick="pluginCancel();" id="pluginCancel">Cancel</button>

			</div>

		</div>

		<div class="modal hide fade span6" id="myModal_Behavior">
			<div class="modal-header">
				<button type="button" id="myModal-close" class="close"
					data-dismiss="modal">×</button>
				<h3>Choose the behaviors of plug-in.</h3>
			</div>
			<div class="modal-body" style="height: 320px;">
				<div class="inset span4 center">
					<div class="span2 behavior-box scroll"
						style="height: 200px; width: 220px;">
						<div id="pluginMethod"></div>
					</div>
					<div class="span2 behavior-box scroll"
						style="height: 200px; width: 220px;">
						<div id="insertPluginAreaPlugins">
							<!-- 显示上个modal中的内容 -->

						</div>
					</div>
				</div>
			</div>
			<div class="modal-footer">

				<button type="button" class="btn btn-inverse"
					onClick="behaviorFinish();" id="behaviorFinish">Finish</button>
				<button type="button" class="btn btn-inverse" onClick="#"
					id="behaviorCancel">Cancel</button>

			</div>

		</div>
		<jsp:include page="publiccontrol/footer.jsp"></jsp:include>

		<!--/.fluid-container-->

		<!-- external javascript
	================================================== -->
		<!-- Placed at the end of the document so the pages load faster -->

		<!-- jQuery -->
		<script src="js/jquery-1.8.2.min.js"></script>
		<script src="js/jquery-ui-1.8.21.custom.min.js"></script>
		<script src="js/jquery.i18n.properties-1.0.9.js"></script>
		<script src="js/bootstrap-modal.js"></script>
		<script src="js/bootstrap-dropdown.js"></script>
		<script src="js/jquery.cookie.js"></script>
		<script src="http://malsup.github.com/jquery.form.js"></script>
		<script src='js/jquery.dataTables.min.js'></script>
		<script src="js/theme.js"></script>
		<script src="script/base.js"></script>
		<script src="script/pluginModel.js"></script>
		<!--  <script src="script/plugin.js"></script> -->
		<script src="script/plugin-new.js"></script>
	</fmt:bundle>
</body>
</html>
