<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<html>
<head>

<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<meta charset="utf-8">
<title>Bench4Q</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description"
	content="Bench4Q, a new method for QOS benchmarking.">
<meta name="author" content="Kai Ren">
<link id="bs-css" href="css/bootstrap-cerulean.css" rel="stylesheet">
<style type="text/css">
</style>
<link rel="shortcut icon" href="img/bench4q.png">
<link href="css/bootstrap-responsive.css" rel="stylesheet">
<link href="css/charisma-app.css" rel="stylesheet">
<link href='css/colorbox.css' rel='stylesheet'>
<link href='css/opa-icons.css' rel='stylesheet'>
<link href='css/jsoneditor.css' rel='stylesheet'>
<link href='bench4q-css/editor.css' rel='stylesheet'>

<!-- The HTML5 shim, for IE6-8 support of HTML5 elements -->
<!--[if lt IE 9]>
	  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->

<!-- The fav icon -->

<script type="text/javascript">
	function toggleAPI() {
		$("#apiDocumentation").slideToggle();
		if ($("#icon-user").attr("class") == "icon-chevron-down") {
			$("#icon-user").attr("class", "icon-chevron-up");
		} else {
			$("#icon-user").attr("class", "icon-chevron-down");
		}

	}

	function toggleAPIContent(apiHeader) {
		switch (apiHeader) {
		case 'apiHeader1': {
			$("#apiContent1").slideToggle();
			if ($("#apiHeader1").attr("class") == "down")
				$("#apiHeader1").attr("class", "up");
			else
				$("#apiHeader1").attr("class", "down");
		}
			break;
		case 'apiHeader2': {
			$("#apiContent2").slideToggle();
			if ($("#apiHeader2").attr("class") == "down")
				$("#apiHeader2").attr("class", "up");
			else
				$("#apiHeader2").attr("class", "down");
		}
			break;
		case 'apiHeader3': {
			$("#apiContent3").slideToggle();
			if ($("#apiHeader3").attr("class") == "down")
				$("#apiHeader3").attr("class", "up");
			else
				$("#apiHeader3").attr("class", "down");
		}
			break;
		default:
			break;
		}
	}
</script>

</head>
<body>
	<fmt:bundle basename="i18n">
		<jsp:include page="publiccontrol/navigatebar.jsp"></jsp:include>
		<div class="container-fluid">
			<div class="row-fluid">
				<jsp:include page="publiccontrol/leftmenubar.jsp"></jsp:include>
				<div class="span10">
					<div id="contents" class="span7">
						<div id="codeEditor"></div>
					</div>

					<!-- API Documentation -->
					<div id="tabBar" class="box span3" style="margin-top: 0px">
						<div class="box-header well" data-original-title>
							<h2>
								<i></i> API Documentation
							</h2>
							<div class="box-icon">
								<a href="#" class="btn btn-minimize btn-round"> <i
									class="icon-chevron-up" id="icon-user" onclick="toggleAPI()"></i>
								</a>
							</div>
						</div>
						<div class="box-content" id="apiDocumentation">
							<div class="span3 main-menu-span" id="sidebar"
								style="width: 245px;">
								<ul class="nav nav-tabs nav-tab nav-stacked "
									style="width: 245px;">

									<li class="api" style="margin-left: 5px;"
										onclick="toggleAPIContent('apiHeader1')"><div
											class="title_style">
											<p class="" id="apiHeader1">poolSize</p>
										</div>
										<div id="apiContent1" class="apiShow">
											<p>The amount of people we simulated to generate actions
												.</p>
										</div></li>


									<li class="api" style="margin-left: 5px;"
										onclick="toggleAPIContent('apiHeader2')">
										<div class="title_style">
											<p class="" id="apiHeader2">usePlugins</p>

										</div>
										<div id="apiContent2" class="apiShow">
											<div>
												<div>
													<div>
														<h3 class="title">usePlugin</h3>
														<p>The plug-ins which help us to create scripts, such
															as CommandLinePlugin ,ConstantTimerPlugin,HttpPlugin and
															LogPlugin.</p>
													</div>
													<div>
														<span class="arguments">Arguments</span>
														<table class="details">
															<tbody>
																<tr>
																	<td>id</td>
																	<td>String</td>
																</tr>
																<tr>
																	<td>The description of plug-in which we used.</td>
																</tr>
																<tr>
																	<td>name</td>
																	<td>String</td>
																</tr>
																<tr>
																	<td>The name of plug-in,such as HTTP,ConstantTimer
																		and so on.</td>
																</tr>
																<tr>
																	<td>parameters</td>
																	<td>Parameter[]</td>
																</tr>
																<tr>
																	<td>The list of parameter,which include the
																		important information of script which you are editing.</td>
																</tr>
															</tbody>
														</table>
													</div>
												</div>
											</div>
										</div>
									</li>
									<li class="api" style="margin-left: 5px;"
										onclick="toggleAPIContent('apiHeader3')">
										<div class="title_style">
											<p class="" id="apiHeader3">pages</p>

										</div>
										<div id="apiContent3" class="apiShow">
											<div>
												<!-- 一段介绍 -->
												<p></p>
												<!-- 结束 -->

												<!-- 参数说明 -->
												<div>
													<div>
														<div>
															<div>
																<h3 class="title">batches</h3>
																<!-- 一段介绍 -->
																<p></p>
																<!-- 结束 -->
															</div>
															<div>
																<span class="arguments">Arguments</span>
																<table class="details">
																	<tbody>
																		<tr>
																			<td>Id</td>
																			<td>int</td>
																		</tr>
																		<!-- 一段介绍 -->
																		<tr>
																			<td>The serial number of batches.</td>
																		</tr>
																		<!-- 结束 -->
																		<tr>
																			<td>parentId</td>
																			<td>int</td>
																		</tr>
																		<!-- 一段介绍 -->
																		<tr>
																			<td>The parent batch's serial number.</td>
																		</tr>
																		<!-- 结束 -->
																		<tr>
																			<td>childId</td>
																			<td>int</td>
																		</tr>
																		<!-- 一段介绍 -->
																		<tr>
																			<td>The child batch's serial number.</td>
																		</tr>
																		<!-- 结束 -->
																		<tr>
																			<td>behaviors</td>
																			<td>Behavior[]</td>
																		</tr>
																		<!-- 一段介绍 -->
																		<tr>
																			<td>A list of actions which you want the script
																				to do.</td>
																		</tr>
																		<!-- 结束 -->
																	</tbody>
																</table>
															</div>
														</div>
														<div>
															<div>
																<div>
																	<h3 class="title">behaviors</h3>
																	<!-- 一段介绍 -->
																	<p>The actions you want the net to do. There are
																		two types of Behavior, namely TimerBehavior and
																		UserBehavior.</p>
																	<!-- 结束 -->
																</div>
																<div>
																	<span class="arguments">Arguments</span>
																	<table class="details">
																		<tbody>
																			<tr>
																				<td>id</td>
																				<td>int</td>
																			</tr>
																			<tr>
																				<td>The serial number of behaviors you have
																					choosed.</td>
																			</tr>
																			<tr>
																				<td>use</td>
																				<td>String</td>
																			</tr>
																			<tr>
																				<td>The type of behaivor, such as time and
																					user.</td>
																			</tr>
																			<tr>
																				<td>name</td>
																				<td>String</td>
																			</tr>
																			<tr>
																				<td>The action name that the behavior
																					executed.For example,when you generate the http
																					request, you can use the method such as
																					GET,POST,PUT and DELETE.</td>
																			</tr>
																			<tr>
																				<td>type</td>
																				<td>String</td>
																			</tr>
																			<tr>
																				<td>The type of behaivor, such as TIMEBEHAVIOR
																					and USERBEHAVIOR.</td>
																			</tr>
																			<tr>
																				<td>parameters</td>
																				<td>Parameter[]</td>
																			</tr>
																			<tr>
																				<td>The list of parameter,which include the
																					important information of script which you are
																					editing.</td>
																			</tr>

																		</tbody>
																	</table>
																</div>

															</div>
														</div>
														<div>
															<div>
																<div>
																	<h3 class="title">parameters</h3>
																	<!-- 一段介绍 -->
																	<p>The specific information of your script.</p>
																	<!-- 结束 -->
																</div>
																<div>
																	<table class="details">
																		<tbody>
																			<tr>
																				<td>key</td>
																				<td>String</td>
																			</tr>
																			<tr>
																				<td>The important parameters when you edit your
																					script.For example, you should write the url(The
																					URL for the resource we are requesting),queryParams
																					and headers (A table of custom HTTP headers to send
																					along with the request)</td>
																			</tr>
																			<tr>
																				<td>value</td>
																				<td>String</td>
																			</tr>
																			<tr>
																				<td>The content of the key.</td>
																			</tr>
																		</tbody>
																	</table>
																</div>
															</div>
														</div>
													</div>
												</div>
												<!-- 结束 -->
											</div>
										</div>
									</li>

								</ul>
							</div>

						</div>
					</div>
					<!-- /API Documentation -->

				</div>
			</div>
			<div id="action">
				<button type="button" class="btn btn-primary" id="submit"
					title="save edit">save</button>

				<button type="button" class="btn btn-primary" id="cancel"
					title="cancel edit">cancel</button>
				<button type="button" class="btn btn-primary" id="validate"
					title="validate edit">validate</button>
			</div>
		</div>
		<hr>
		<jsp:include page="publiccontrol/footer.jsp"></jsp:include>

		<!-- external javascript
	================================================== -->
		<!-- Placed at the end of the document so the pages load faster -->

		<!-- jQuery -->
		<script src="js/jquery-1.7.2.min.js"></script>
		<!--jQuery UI  -->
		<script src="js/jquery.i18n.properties-1.0.9.js"></script>
		<script src="js/bootstrap-dropdown.js"></script>
		<script src="js/jquery.cookie.js"></script>
		<script src="js/script-edit-uri.js"></script>
		<script src="js/script-edit-jsv.js"></script>
		<script src="js/script-edit-json-schema-draft.js"></script>
		<script src="js/jsoneditor.js"></script>
		<script src="js/lib/ace/ace.js"></script>
		<script src="js/lib/ace/mode-json.js"></script>
		<script src="js/lib/ace/theme-textmate.js"></script>
		<script src="js/lib/ace/theme-jsoneditor.js"></script>
		<script src="script/jsonEditorApp.js"></script>
		<script src="js/theme.js"></script>
		<script src="script/editScript.js"></script>
		<script src="script/base.js"></script>
	</fmt:bundle>
</body>
</html>
