<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<html>
<head>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<meta charset="utf-8">
<title>Bench4Q</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description"
	content="Bench4Q, a new method for QOS benchmarking.">
<meta name="author" content="Kai Ren">

<!-- The styles -->
<link rel="shortcut icon" href="img/bench4q.png">
<link id="bs-css" href="css/bootstrap-cerulean.css" rel="stylesheet">
<style type="text/css">
body {
	padding-bottom: 40px;
}

.sidebar-nav {
	padding: 9px 0;
}
</style>
<link href="css/bootstrap-responsive.css" rel="stylesheet">
<link href="css/charisma-app.css" rel="stylesheet">
<link href="css/jquery-ui-1.8.21.custom.css" rel="stylesheet">
<link href='css/chosen.css' rel='stylesheet'>
<link href='css/uniform.default.css' rel='stylesheet'>
<link href='css/colorbox.css' rel='stylesheet'>
<link href='css/jquery.noty.css' rel='stylesheet'>
<link href='css/noty_theme_default.css' rel='stylesheet'>
<link href='css/elfinder.min.css' rel='stylesheet'>
<link href='css/elfinder.theme.css' rel='stylesheet'>
<link href='css/opa-icons.css' rel='stylesheet'>
<link href='css/uploadify.css' rel='stylesheet'>
<link href='bench4q-css/test-new.css' rel='stylesheet'>

<!-- The HTML5 shim, for IE6-8 support of HTML5 elements -->
<!--[if lt IE 9]>
	  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->

<!-- The fav icon -->
<link rel="shortcut icon" href="img/favicon.ico">

</head>

<body>
	<fmt:bundle basename="i18n">
		<!-- topbar starts -->
		<jsp:include page="publiccontrol/navigatebar.jsp"></jsp:include>
		<!-- topbar ends -->
		<div class="container-fluid">
			<div class="row-fluid">
				<jsp:include page="publiccontrol/leftmenubar.jsp"></jsp:include>
				<noscript>
					<div class="alert alert-block span10">
						<h4 class="alert-heading">
							<fmt:message key="warning" />
							!
						</h4>
						<p>
							<fmt:message key="warningcontent1" />
							<a href="http://en.wikipedia.org/wiki/JavaScript" target="_blank">JavaScript</a>
							<fmt:message key="warningcontent2" />
							.
						</p>
					</div>
				</noscript>

				<div id="content" class="span10">
					<!-- content starts -->
					<div>
						<ul class="breadcrumb">
							<li><a href="homepage.jsp"><fmt:message key="home" /></a> <span
								class="divider">/</span></li>
							<li><a href="#"><fmt:message key="scriptmanagement" /></a></li>
						</ul>
					</div>

					<div class="row-fluid sortable">
						<div class="box span12">
							<div class="box-header well" data-original-title>
								<h2>
									<i></i>
									<fmt:message key="script" />
								</h2>
								<div class="box-icon">
									<a href="#" class="btn btn-setting btn-round"><i
										class="icon-plus"></i></a> <a href="#" class="btn btn-round"
									><i class="icon-list"></i></a> <a
										href="#" class="btn btn-minimize btn-round"><i
										class="icon-chevron-up"></i></a>
								</div>
							</div>
							<div class="box-content">
								<table id="scriptTab"
									class="table table-striped table-bordered bootstrap-datatable datatable">
									<thead>
										<tr>
											<th><fmt:message key="scriptname" /></th>
											<th>ID</th>
											<th><fmt:message key="datecreated" /></th>
											<th><fmt:message key="actions" /></th>
										</tr>
									</thead>
									<tbody>
									</tbody>
								</table>
							</div>
						</div>
						<!--/span-->

					</div>
					<!--/row-->
					
					<!-- 添加脚本 -->
					<div>
						<table>
				    		<tr>
				    			<td>
									<button id="createNewScript" class="btn btn-primary btn-setting" 
									onclick="" type="submit">录制脚本
    				   				 </button>
    				   				 
    				   				 <button id="createScript" class="btn btn-primary" 
									onclick="#" type="submit">自制脚本
    				   				 </button>
    				    
    				   				 <button id="refreshPage" class="btn btn-info " 
    				   				 onclick="refresh()" type="submit">刷新页面
    				    			</button>    				    							    			
    				    		</td>
							</tr>
						</table>
					</div>
					<!-- /addScript -->


					<!-- content ends -->
				</div>
				<!--/#content.span10-->

			</div>
			<hr>

			<div class="modal hide fade" id="myModal">
				<div class="modal-header">
					<button type="button" id="myModal-close" class="close" data-dismiss="modal">×</button>
					<h3>
						<fmt:message key="settings" />
					</h3>
				</div>
				<div class="modal-body">
					<p id="scriptInfo">
						 start server to generate a script or upload a script to server
					</p>
				</div>
				<div class="modal-footer">
				
					<button type="button" class="btn btn-primary"
						onClick="startServer()" id="startServer">
						<fmt:message key="startserver" />
					</button>
					<button type="button" class="btn btn-primary"
						onClick="stopServer()" id="stopServer">
						<fmt:message key="stopserver" />
					</button>
					<button type="button" id="uploadScript" class="btn btn-primary">
						<fmt:message key="uploadScript" />
					</button>
				</div>
				<div id="fileName" style="display: none" class="modal-footer">
					<input class="input-mini" name="scriptname"></input>
					<button type="button" class="btn btn-primary"
						onClick="saveScript()">
						<fmt:message key="savefile" />
					</button>
				</div>
			</div>
			<jsp:include page="publiccontrol/footer.jsp"></jsp:include>

		</div>
		<!--/.fluid-container-->

		<!-- external javascript
	================================================== -->
		<!-- Placed at the end of the document so the pages load faster -->

		<!-- jQuery -->
		<script src="js/jquery-1.8.2.min.js"></script>
		<script src="js/jquery-ui-1.8.21.custom.min.js"></script>
		<script src="js/jquery.i18n.properties-1.0.9.js"></script>
		<script src="js/bootstrap-modal.js"></script>
		<script src="js/bootstrap-dropdown.js"></script>
		<script src="js/jquery.cookie.js"></script>
		<script src="http://malsup.github.com/jquery.form.js"></script>
		<script src='js/jquery.dataTables.min.js'></script>
		<script src="js/theme.js"></script>
		<script src="script/base.js"></script>
		<script src="script/scriptTable.js"></script>
		<script src="script/script.js"></script>
	</fmt:bundle>
</body>
</html>
