
var agentColumnIndex={"hostName":0,"id":1,"port":2,"currentStatus":3,"maxLoad":4,"remainLoad:":5,"action":6};
var agentTableModel=new Array("hostName","id","port","currentStatus","maxLoad","remainLoad");
var deleteButton = "<a class='btn btn-info delete' ><i class='icon-trash icon-white'></i>Delete</a>";

$(document).ready(function() {
	var table = $('#agents');
	loadAgents(table);

	
});
function loadAgents(table) {
	table.dataTable().fnClearTable();
	$.post("loadAgents", {}, function(data) {
		if (data != null) {
			if(data.list!=null)
			for ( var i = 0; i < data.list.length; i++)
				addAgentTableRow(table, data.list[i]);
		}
		$('.delete').click(function(e) {
			e.preventDefault();
			deleteAgent(this);
		});
	}, "json");
	
}

function addAgentTableRow(table, data) {
	data.currentStatus=getAgentStatus(data.currentStatus);
	table.dataTable().fnAddData(extractRowData(data,agentTableModel,deleteButton));
}
function getAgentStatus(agentStatusCode){
	var status = "NA";
	switch (agentStatusCode) {
	case 1:
		status = "Idle";
		break;
	case 2:
		status = "Running";
		break;
	case 3:
		status = "BackUp";
		break;
	case 4:
		status = "BreakDown";
		break;
	default:
		status = "NA";
		break;
	}
	return status;
}
function deleteAgent(obj) {
	var table =getTable(obj);
	var row=getRow(obj);
	$.post("removeAgentFromPool", {
		id :  getColumn(obj,agentColumnIndex.id),
		hostName:getColumn(obj,agentColumnIndex.hostName)
	}, function(data) {
		if (data)
			$(table).dataTable().fnDeleteRow(row.rowIndex - 1);
		else {
			alert("fail");
		}

	});

}
function addAgentToDB() {
	var table=$('#agents');
	$.post("addAgentToPool", {
		hostName : $("#hostName").val(),
		port : $("#port").val(),
		maxLoad : $("#maxLoad").val(),
		remainLoad : $("#remainLoad").val()
	}, function(data) {
		if (data) {
			loadAgents(table);
		}
		else{
			alert("fail");
		}
	});
}
$('#agentList').click(function(e){
	e.preventDefault();
	var table = $('#agents');
	loadAgents(table);
});
$('.btn-setting').click(function(e) {
	e.preventDefault();
	$("#agentParam").modal('show');
});
