$('.dataTable').dataTable({
	"sDom" : "<'row-fluid'<'span6'l>>t<'row-fluid'<'span3 center'p>>",
	"sPaginationType" : "bootstrap",
	"oLanguage" : {
		"sLengthMenu" : "_MENU_ records per page",

	},
	"bDestroy" : true
});
// get script list in running test plan------------------------------------

function getScriptList(testPlanId) {
	var scriptList = new Array();
	$.ajax({
		type : "POST",
		url : testPlanId + "/queryTestPlan",
		dataType : "json",
		async : false,
		success : function(data) {
			if(!data.success){
				alert(data.failedMessage);
				return;
			}
			else data=data.data;
			if (data.scriptIds.length <= 0)
				return null;
			for ( var i = 0; i < data.scriptIdNameMap.length; i++) {
				scriptList.push(data.scriptIdNameMap[i]);
			}

		}
	});
	return scriptList;

}
// page-----------------------------------------------------------

var PageResult = function() {
	this.result = new Array();
	this.intevalTime = 5000;
	this.header = new Array("page", "scriptName", "countFromBegin",
			"minResponseTimeFromBegin", "maxResponseTimeFromBegin",
			"averageResponseTimeThisTime", "latestResponseTime");
	this.table = $("#page").dataTable();

};
PageResult.prototype.addResultToTable = function() {
	this.table.fnClearTable();
	var result = this.result;
	for ( var i = 0; i < result.length; i++) {
		var row = extractRowDataActionBefore(result[i], this.header, null);
		this.table.fnAddData(row);
	}
	loadItems.pageResult=true;
	
};
var PageResultModel = function(page, scriptPageBriefModel, scriptName) {
	this.page = page;
	this.countFromBegin = scriptPageBriefModel.countFromBegin;
	this.minResponseTimeFromBegin = scriptPageBriefModel.minResponseTimeFromBegin;
	this.maxResponseTimeFromBegin = scriptPageBriefModel.maxResponseTimeFromBegin;
	this.averageResponseTimeThisTime = scriptPageBriefModel.averageResponseTimeThisTime;
	this.latestResponseTime = scriptPageBriefModel.latestResponseTime;
	this.scriptName = scriptName;
};

PageResult.prototype.getResult = function(testPlanId, scriptList) {
	var pageResult = this;
	var finishedCount = 0;
	var count=0;
	var intervalId = setInterval(function() {
		count++;
		pageResult.addResultToTable();
		if (finishedCount >= scriptList.length) {
			clearInterval(intervalId);
			return;
		}

		if (scriptList.length == 0) {
			clearInterval(intervalId);
			return;
		}
		pageResult.result = [];
		finishedCount = 0;
		for ( var i = 0; i < scriptList.length; i++) {
			pageResult.getSinglePageResult(pageResult, intervalId,
					finishedCount, scriptList[i]);
		}
		if (testStatus == "Complete" && count == 2) {
			clearInterval(intervalId);
			return;
		}
	}, this.intevalTime);

};
PageResult.prototype.getSinglePageResult = function(pageResult, intervalId,
		finishedCount, script) {
	var urlPath = [ testPlanId, "script", script.key, "page" ];
	var url = generateUrl(urlPath);
	$.post(url, {}, function(data) {
		if(!data.success){
			clearInterval(intervalId);
			return;
		}
			
		else data=data.data;
		data = data.scriptPageBriefModels;
		var scriptPagesFinished = true;
		for ( var i = 0; i < data.length; i++) {
			pageResult.result = $.merge(pageResult.result,
					[ new PageResultModel("page" + i, data[i],
							script.value) ]);
			if (!data[i].finished)
				scriptPagesFinished = false;
			
		}
		if (scriptPagesFinished)
			finishedCount++;

	}, "json");
};

// Behavior-------------------------------------------------------
var BehaviorResult = function() {
	this.behaviors = new Array();
	this.intevalTime = 5000;
	this.header = new Array("Url", "Script", "Successful", "Total");
	this.actionAdd = "<img src='images/add.png' alt='details' title='details' class='show-detail-picture'>";
	this.actionDelete = "<img src='images/add.png' alt='details' title='details' class='detail-picture'>";
	this.table = $("#url").dataTable();

};
BehaviorResult.prototype.getResult = function(testPlanId, scriptList) {
	var behaviorResult = this;
	var finishedCount = 0;
	var count = 0;
	var intervalId = setInterval(function() {
		count++;
		behaviorResult.addBehaviorsToTable();
		behaviorResult.DetailAddListener();
		if (finishedCount >= scriptList.length) {
			clearInterval(intervalId);
			return;
		}

		if (scriptList.length == 0) {
			clearInterval(intervalId);
			return;
		}
		behaviorResult.behaviors = [];
		finishedCount = 0;
		for ( var i = 0; i < scriptList.length; i++) {
			behaviorResult.getSingleBehaviorResult(behaviorResult, intervalId,
					finishedCount, scriptList[i]);
		}
		if (testStatus == "Complete" && count == 2) {
			clearInterval(intervalId);
			return;
		}

	}, this.intevalTime);

};
function generateUrl(urlPath) {
	var url = urlPath[0];
	for ( var i = 1; i < urlPath.length; i++)
		url += "/" + urlPath[i];
	return url;

}
BehaviorResult.prototype.getSingleBehaviorResult = function(behaviorResult,
		intevalId, finishedCount, script) {
	var urlPath = [ testPlanId, "script", script.key, "behaviors" ];
	var url = generateUrl(urlPath);
	$.post(url, {}, function(data) {
		if (!data.success) {
			clearInterval(intervalId);
			return;
		}
		data=data.data;
		if (data.finished || data.testBehaviorsBriefModel == null) {
			finishedCount++;
		}
		if (data.testBehaviorsBriefModel != null)
			behaviorResult.behaviors = $.merge(behaviorResult.behaviors,
					behaviorResult.getBehaviorsList(
							data.testBehaviorsBriefModel.behaviorBriefModels,
							script.value));

	}, "json");
};
var Behavior = function(behaviorBriefModel, scriptName) {
	this.behaviorBriefModel = behaviorBriefModel;
	this.scriptName = scriptName;
};
BehaviorResult.prototype.getBehaviorsList = function(behaviorBriefModels,
		scriptName) {
	var behaviors = new Array();
	for ( var i = 0; i < behaviorBriefModels.length; i++) {
		behaviors.push(new Behavior(behaviorBriefModels[i], scriptName));
	}
	return behaviors;
};

BehaviorResult.prototype.addBehaviorsToTable = function() {
	this.table.fnClearTable();
	var behaviors = this.behaviors;
	for ( var i = 0; i < behaviors.length; i++) {
		var row = extractRowDataActionBefore(new BehaviorModel(
				behaviors[i].behaviorBriefModel, behaviors[i].scriptName),
				this.header, this.actionAdd);
		this.table.fnAddData(row);
	}
	loadItems.behaviorResult=true;
};
BehaviorResult.prototype.DetailAddListener = function() {
	var behaviorResult = this;
	$(".show-detail-picture")
			.click(
					function() {
						if (this.parentNode != null) {
							var brotherDom = $(this.parentNode.parentNode);
							var url = getColumn(this, 1);
							behaviorResult.showUrlDetailResult(brotherDom, url);
							var td = $(this.parentNode);
							td.html("");
							td
									.html('<img src="images/delete.png" alt="details" title="details" class="delete-detail-picture">');
							behaviorResult.DetailAddListener();
						}
					});
	$(".delete-detail-picture")
			.click(
					function() {
						if (this.parentNode != null) {
							var brotherDom = $(this.parentNode.parentNode);
							brotherDom.next("tr").remove();
							var td = $(this.parentNode);
							td.html("");
							td
									.html('<img src="images/add.png" alt="details" title="details" class="show-detail-picture">');
							behaviorResult.DetailAddListener();
						}

					});
};;
BehaviorResult.prototype.showUrlDetailResult = function(brotherDom, url) {
	var theader = [ "url", "statusCode", "count", "contentLength",
			"minResponseTime", "maxResponseTime", "totalResponseTimeThisTime" ];
	var behavior = this.searchBehaviorByUrl(url);
	if (behavior == null)
		return;
	var dataRows = new Array();
	for ( var i = 0; i < behavior.behaviorBriefModel.detailStatusCodeResultModels.length; i++) {
		dataRows.push(extractRowDataActionBefore(new BehaviorDetailModel(url,
				behavior.behaviorBriefModel.detailStatusCodeResultModels[i]),
				theader, null));
	}
	var tr = this.drawUrlDetailResult(theader, dataRows);
	tr.insertAfter(brotherDom);
	var table = $(tr.children("td").children("div").children("table")[0]);
	for ( var i = 0; i < dataRows.length; i++) {
		this.addDataToDetailTable($(table.children("tbody")[0]), dataRows[i]);
	}

};
BehaviorResult.prototype.addDataToDetailTable = function(tbody, dataRow) {
	var tr = $("<tr></tr>");
	for ( var i = 0; i < dataRow.length; i++) {
		var td = $("<td></td>");
		td.html(dataRow[i]);
		tr.append(td);
	}
	tbody.append(tr);
};
BehaviorResult.prototype.drawUrlDetailResult = function(theader) {
	var table = this.getDetaileTable(theader);
	var div = $("<div></div>");
	div.append(table);
	var td = $("<td colspan='5'></td>");
	td.append(div);
	var tr = $("<tr></tr>");
	tr.append(td);
	return tr;

};
BehaviorResult.prototype.getDetaileTable = function(theader) {
	var table = $("<table></table>");
	table.addClass("innerTable");
	var thead = $("<thead></thead>");
	var tr = $("<tr></tr>");
	for ( var i = 0; i < theader.length; i++) {
		tr.append("<th>" + theader[i] + "</th>");
	}
	thead.append(tr);
	table.append(thead);
	table.append("<tbody></tbody>");
	// add table row

	return table;

};

BehaviorResult.prototype.searchBehaviorByUrl = function(url) {
	var behaviors = this.behaviors;
	for ( var i = 0; i < behaviors.length; i++) {
		if (behaviors[i].behaviorBriefModel.behaviorUrl == url) {
			return behaviors[i];
		}
	}
	return null;
};

var BehaviorModel = function(behavior, scriptName) {
	this.Url = behavior.behaviorUrl;
	this.Script = scriptName;
	this.Successful = this.getStatusCount(
			behavior.detailStatusCodeResultModels, 200);
	this.Total = this.getTotalCount(behavior.detailStatusCodeResultModels);
};
var BehaviorDetailModel = function(url, behaviorDetaile) {
	this.url = url;
	for ( var key in behaviorDetaile) {
		if (key.indexOf("contentType") < 0)
			this[key] = behaviorDetaile[key];
	}
};
BehaviorModel.prototype.getStatusCount = function(behaviorStatusResultList,
		statusCode) {
	if (behaviorStatusResultList == null)
		return 0;
	var count = 0;
	for ( var i = 0; i < behaviorStatusResultList.length; i++) {
		if (behaviorStatusResultList[i].statusCode == statusCode)
			count += behaviorStatusResultList[i].count;
	}
	return count;
};
BehaviorModel.prototype.getTotalCount = function(behaviorStatusResultList) {
	if (behaviorStatusResultList == null)
		return 0;
	var count = 0;
	for ( var i = 0; i < behaviorStatusResultList.length; i++) {
		count += behaviorStatusResultList[i].count;
	}
	return count;
};

// need to abstract the tow
// part----------------------------------------------------
