package org.bench4q.web.api.test;

import java.util.ArrayList;
import java.util.List;
import org.bench4q.share.models.master.ScriptModel;
import org.bench4q.web.TestPlan.RunTestPlan;
import org.bench4q.web.api.ScriptActionController;
import org.bench4q.web.exception.CustomGenericException;
import org.bench4q.web.model.TestPlanRequestModel;
import org.bench4q.web.model.WebScriptModel;
import org.bench4q.web.tool.test.LoginHelper;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "file:src/main/resources/bench4qweb-servlet.xml" })
public class RunTestPlanTest {

	private ScriptActionController scriptActionController;
	private RunTestPlan runTestPlan;
	private LoginHelper loginHelper;
	public LoginHelper getLoginHelper() {
		return loginHelper;
	}
	@Autowired
	public void setLoginHelper(LoginHelper loginHelper) {
		this.loginHelper = loginHelper;
	}
	private String accessToken;
	private ScriptActionController getScriptActionController() {
		return scriptActionController;
	}

	@Autowired
	private void setScriptActionController(
			ScriptActionController scriptActionController) {
		this.scriptActionController = scriptActionController;
	}

	private RunTestPlan getRunTestPlan() {
		return runTestPlan;
	}

	@Autowired
	private void setRunTestPlan(RunTestPlan runTestPlan) {
		this.runTestPlan = runTestPlan;
	}

	@Before
	public void setUp() {
		this.accessToken = loginHelper.Login();
	}

	@SuppressWarnings("unchecked")
	@Test
	public void runTestPlanTest() throws CustomGenericException {

		TestPlanRequestModel testPlanRequestModel = new TestPlanRequestModel();

		WebScriptModel webScriptModel = new WebScriptModel();
		webScriptModel.setCooldown(1);
		webScriptModel.setWarmup(1);
		webScriptModel.setLoad(100);
		webScriptModel.setExecuteRange(50);
		List<ScriptModel> scripts = (List<ScriptModel>) this
				.getScriptActionController().loadScript(accessToken).getData();
		webScriptModel.setId(scripts.get(0).getId());
		List<WebScriptModel> webScriptModels = new ArrayList<WebScriptModel>();
		webScriptModels.add(webScriptModel);
		testPlanRequestModel.setScriptList(webScriptModels);
		this.getRunTestPlan().runTestPlan(accessToken, testPlanRequestModel,
				this.getLoginHelper().modelMap);
		testPlanRequestModel.setTestPlanName("test");
		testPlanRequestModel.setIpList(new ArrayList<String>());
		
	}

}
